unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, UniUsbHost,
  FMX.Objects, FMX.StdCtrls;

type
  TMainForm = class(TForm)
    Rectangle1: TRectangle;
    UniUsbHost1: TUniUsbHost;
    Version: TButton;
    Rectangle2: TRectangle;
    Rectangle3: TRectangle;
    Rectangle4: TRectangle;
    UsbPort: TButton;
    procedure UniUsbHost1UsbAttach(Sender: TObject);
    procedure UniUsbHost1UsbDettach(Sender: TObject);
    procedure VersionClick(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure UsbPortClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { private 錾 }
  private var
    DataBuf  : array [0..63] of Byte;
  public
    { public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.fmx}

procedure TMainForm.UsbPortClick(Sender: TObject);
begin
  if UsbPort.Text.Equals('Open') = TRUE then
  begin
    UsbPort.Text := 'Close';
    UniUsbHost1.Open;
  end
  else
  begin
    UsbPort.Text := 'Open';
    UniUsbHost1.Close;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    UniUsbHost1.Close;
end;

procedure TMainForm.Rectangle1Click(Sender: TObject);
begin
    if(Sender as TRectangle).Fill.Color <> TAlphaColorRec.Blue then
    begin
        (Sender as TRectangle).Fill.Color := TAlphaColorRec.Blue;
    end
    else
    begin
        (Sender as TRectangle).Fill.Color := TAlphaColorRec.White;
    end;

    FillChar(DataBuf,sizeof(DataBuf), 0);
    DataBuf[0] := 06;       ;
    DataBuf[1] := Byte('L');
    DataBuf[2] := 0;
    if(Rectangle1.Fill.Color = TAlphaColorRec.Blue) then DataBuf[2] := DataBuf[2] or $01;
    if(Rectangle2.Fill.Color = TAlphaColorRec.Blue) then DataBuf[2] := DataBuf[2] or $02;
    if(Rectangle3.Fill.Color = TAlphaColorRec.Blue) then DataBuf[2] := DataBuf[2] or $04;
    if(Rectangle4.Fill.Color = TAlphaColorRec.Blue) then DataBuf[2] := DataBuf[2] or $08;
    if ( UniUsbhost1.Write( 1 , 64 ,@DataBuf)  <> 0 ) then
    begin
      ShowMessage('UsbData Send Error!');
      Exit;
    end;
    FillChar(DataBuf,sizeof(DataBuf), 0);
end;

procedure TMainForm.UniUsbHost1UsbAttach(Sender: TObject);
begin
//////////// AhChpUSB DEVICE}̃Cxgł//////////
    showMessage('USB Attach');
end;

procedure TMainForm.UniUsbHost1UsbDettach(Sender: TObject);
begin
//////////// AhChpUSB DEVICE𔲂̃Cxgł//////////
    showMessage('USB Dettach');
end;

procedure TMainForm.VersionClick(Sender: TObject);
var
str2 : String;
str : string;
  I: Integer;
  ret : byte;

begin
    FillChar(DataBuf,sizeof(DataBuf), 0);
    DataBuf[0] := 06;
    DataBuf[1] := Byte('V');


    str2 := '';
//@End point Check!!
     for I := 0 to 7 do

       Str2 := Str2+ IntToHex(UniUsbhost1.BulkPipe[i],2)+' ';

     MainForm.Caption := Str2;

    ret  := UniUsbhost1.Write( 1 , 64 ,@DataBuf) ;
    if ( ret <> 0 ) then
    begin
      ShowMessage('UsbData Send Error!');
      Exit;
    end;
    FillChar(DataBuf,sizeof(DataBuf), 0);
    Sleep(5); //  Wait ͕Kv!

    if ( UniUsbhost1.Read(0, 64,@DataBuf ) = 0 ) then
    begin
       Str := 'USB Version Get Error ';
      if (DataBuf[1] = Byte('V')) then
       Str := 'USB Firm Version : '
                 +Char(byte('0') or (DataBuf[3]))
                 +Char('.')
                 +Char(byte('0') or (DataBuf[4]))
                 +Char(byte('0') or (DataBuf[5]));
       ShowMessage(Str);
    end;
end;

end.
